Subject: bug#4142: [PATCH] 23.1 info.el::Info-goto-node - Wrong type argument:stringp, nil

From: Juri Linkov <[email-masked]>
Date: Sat, 17 Sep 2011 21:17:55 +0300

>> So I don't think this is an Emacs bug, but should be fixed in the
>> emacs-w3m manual instead.
>
> It would seem that the bug, or enhancement request, is that Emacs not have such
> a fragile way of recognizing an index node.

emacs-w3m.info dates 7 Jul 2006, so it's very unlikely that its authors
will fix the emacs-w3m Info manual in the near future.  So yes, we could
try making Info less fragile.

> Depending on the node name is a bit sophomorish, no?  We have lots of meta info
> that is not displayed to the user but is used for Info to do its job.  This
> sounds like another place where we should make use of that possibility.

The current situation in emacs-w3m is worse.  The Info reader recognizes
non-index nodes as index nodes, and vice-versa - index nodes as non-index nodes.

Currently a node is recognized as index based on its name solely.
If its name contains the word "Index", it's an index node, the same
is checked for its adjacent nodes.

Instead of checking the node name we could visit all nodes in the manual
with the name containing the word "Index" and check if the first menu item
has the format of index or not.

I believe this would be more reliable with no performance impact.